class CircularArray {
	int *array;
	int npositions;
	int head;
	int tail;
	int nelem;
	
	pthread_mutex_t m;
	pthread_cond_t prod;
	pthread_cond_t cons;

  public:
	CircularArray(int n);
	void insert(int dato);
	int extract();	
};


CircularArray::CircularArray(int n)
{
	npositions = n;
	nelem = 0;
	array = new int[n];
	head = tail = 0;
	
	pthread_mutex_init(&m, 0);
	pthread_cond_init(&prod, 0);
	pthread_cond_init(&cons, 0);
}

void CircularArray::insert(int d)
{
	// prendi la mutua esclusione
	pthread_mutex_lock(&m);
	while (nelem == nposition) {
	  	// block
		pthread_cond_wait(&prod, &m);
	}
	array[head] = d;
	head = (head + 1) % npositions

	// sveglia consumatori in attesa
	pthread_cond_signal(&cons);

	// rilascia la mutua esclusione
	pthread_mutex_unlock(&m);
}

int CircularArray::extract()
{
	int d;
	// prendi la mutua esclusione
	pthread_mutex_lock(&m);

	while (nelem == 0) {
		//block
		pthread_cond_wait(&cons, &m);
	}
	d = array[tail];
	tail = (tail + 1) % npositions;

	// sveglia produttori in attesa
	pthread_cond_signal(&prod);

	// rilascia la mutua esclusione
	pthread_mutex_unlock(&m);
	return d;
}






