#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include "synchperiodic.h"
#include "time_utils.hpp"

struct periodic_data {
  int index;
  long period_us;
  int wcet_sim;
};

void waste(int k)
{
  int a = 13, b = 17, j;
  for (j=0; j < k; j++) a *= b;
  
}

#define NTHREADS 3

PeriodicBarrier pb(NTHREADS);

void *thread_code(void *arg) {
  struct periodic_data *ps = (struct periodic_data *) arg;
  struct timespec next;

  pb.wait(&next);

  while (1) {
    fprintf(stdout, "TH %d activated at time %ld\n", ps->index,
	    next.tv_nsec/1000);

    waste(ps->wcet_sim);

    timespec_add_us(&next, ps->period_us);
    clock_nanosleep(CLOCK_REALTIME, TIMER_ABSTIME,
		    &next, NULL);
  }
  return NULL;
}

int main(void) {
  pthread_t th[NTHREADS];
  pthread_attr_t myattr;
  int i;
  long periods[NTHREADS] = {300000, 200000, 100000};
  int wcets[NTHREADS] = {300000, 200000, 100000};
  struct periodic_data st[NTHREADS];
  struct sched_param myparam;
  
  fprintf(stderr,"Press 's' to start and 'q' to finish\n");

  pthread_attr_init(&myattr);   
  for (i=0; i<NTHREADS; i++) {
    st[i].index = i;
    st[i].period_us = periods[i];
    st[i].wcet_sim = wcets[i];

    pthread_attr_setschedpolicy(&myattr, SCHED_FIFO);
    myparam.sched_priority = i+10;
    pthread_attr_setschedparam(&myattr, &myparam);   
    pthread_create(&th[i], &myattr, thread_code, &st[i]);    
  }

  pthread_attr_destroy(&myattr);

  while (1) {
    char  c = getchar();
    if (c == 'q') break;
    if (c == 's') pb.start();
  }
}
