#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include "time_utils.h"

struct periodic_data_struct {
  int index;
  long period_us;
  int wcet_sim;
};

void *thread_code(void *arg) {
  struct periodic_data_struct *ps = (struct periodic_data_struct *) arg;
  struct timespec next;
  struct timespec now, diff;
  int j, a=13, b=17;
  long max = 0;

  clock_gettime(CLOCK_REALTIME, &next);
  while (1) {                                        
    clock_gettime(CLOCK_REALTIME, &now);
    timespec_add_us(&next, ps->period_us);

/*     fprintf(stderr,"th: %d, now is %ld, waking up at %ld\n", */
/* 	   ps->index, now.tv_nsec, next.tv_nsec); */

    if (timespec_cmp(&now, &next) > 0) {
      fprintf(stderr, "Deadline miss for thread %d\n", ps->index);
      fprintf(stderr, "now: %d sec %ld nsec     next: %d sec %ldnsec \n", 
	      now.tv_sec, now.tv_nsec, next.tv_sec, next.tv_nsec);
      exit(-1);
    }

    clock_nanosleep(CLOCK_REALTIME, TIMER_ABSTIME,
		    &next, NULL);
    clock_gettime(CLOCK_REALTIME, &now);

    timespec_sub(&diff, &now, &next);
    if (max < diff.tv_nsec) max = diff.tv_nsec;

    fprintf(stdout,"diff: %ld\t\tmax = %ld\n", diff.tv_nsec/1000, max/1000);

    for (j=0; j<ps->wcet_sim; j++) a *= b;

/*     fprintf(stderr,"th: %d completed\n", ps->index); */
  }
  return NULL;
}

int main(void) {
  pthread_t th;
  pthread_attr_t myattr;
  int i = 0;
  struct periodic_data_struct st;
  struct sched_param myparam;
  
  fprintf(stderr,"Press 'q' to finish\n");

  pthread_attr_init(&myattr);   
  st.index = 0;
  st.period_us = 85000;
  st.wcet_sim = 1000;

  pthread_attr_setschedpolicy(&myattr, SCHED_FIFO);
  myparam.sched_priority = 10;
  pthread_attr_setschedparam(&myattr, &myparam);   
  pthread_create(&th, &myattr, thread_code, &st);    
  
  pthread_attr_destroy(&myattr);

  while (1) {
   if (getchar() == 'q') break;
  }
  return 0;
}
