#include "synchperiodic.h"

PeriodicBarrier::PeriodicBarrier(int n) :
  nthreads(n), blocked(0)
{
  pthread_mutex_init(&m, 0);
  pthread_cond_init(&c_threads, 0);
  pthread_cond_init(&c_manager, 0);
}

void PeriodicBarrier::wait(struct timespec *a)
{
    pthread_mutex_lock(&m);
    blocked++;
    if (blocked == nthreads) 
        pthread_cond_signal(&c_manager);

    pthread_cond_wait(&c_threads, &m);
    *a = arrival;
    pthread_mutex_unlock(&m);
}

void PeriodicBarrier::start()
{
    pthread_mutex_lock(&m);
    if (blocked < nthreads) 
        pthread_cond_wait(&c_manager, &m);

    pthread_cond_broadcast(&c_threads);
    clock_gettime(CLOCK_REALTIME, &arrival);
    pthread_mutex_unlock(&m);
}


